glibmm: Gio::TcpWrapperConnection Class Reference

glibmm 2.66.8

Public Member Functions | Static Public Member Functions | Related Symbols | List of all members
Gio::TcpWrapperConnection Class Reference
Portable Network I/O Functionality

Wrapper for non-GioSocketConnection-based, Gio::Socket-based Gio::IOStreams. More...

`#include <giomm/tcpwrapperconnection.h>`

Inheritance diagram for Gio::TcpWrapperConnection:
[legend]

## Public Member Functions
| TcpWrapperConnection (TcpWrapperConnection && src) noexcept
TcpWrapperConnection & | operator= (TcpWrapperConnection && src) noexcept
| ~TcpWrapperConnection () noexcept override
GTcpWrapperConnection * | gobj ()
| Provides access to the underlying C GObject.
const GTcpWrapperConnection * | gobj () const
| Provides access to the underlying C GObject.
GTcpWrapperConnection * | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.
| TcpWrapperConnection (const Glib::RefPtr< IOStream > & base_io_stream, const Glib::RefPtr< Socket > &socket)
Glib::RefPtr< IOStream > | get_base_io_stream ()
| Gets conn's base IOStream.
Glib::RefPtr< const IOStream > | get_base_io_stream () const
| Gets conn's base IOStream.
Glib::PropertyProxy_ReadOnly< Glib::RefPtr< IOStream > > | property_base_io_stream () const
| The wrapped GIOStream.
Public Member Functions inherited from Gio::TcpConnection
| TcpConnection (TcpConnection && src) noexcept
TcpConnection & | operator= (TcpConnection && src) noexcept
| ~TcpConnection () noexcept override
GTcpConnection * | gobj ()
| Provides access to the underlying C GObject.
const GTcpConnection * | gobj () const
| Provides access to the underlying C GObject.
GTcpConnection * | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.
void | set_graceful_disconnect (bool graceful_disconnect)
| This enables graceful disconnects on close.
bool | get_graceful_disconnect () const
| Checks if graceful disconnects are used.
Glib::PropertyProxy< bool > | property_graceful_disconnect ()
| Whether or not close does a graceful disconnect.
Glib::PropertyProxy_ReadOnly< bool > | property_graceful_disconnect () const
| Whether or not close does a graceful disconnect.
Public Member Functions inherited from Gio::SocketConnection
| SocketConnection (SocketConnection && src) noexcept
SocketConnection & | operator= (SocketConnection && src) noexcept
| ~SocketConnection () noexcept override
GSocketConnection * | gobj ()
| Provides access to the underlying C GObject.
const GSocketConnection * | gobj () const
| Provides access to the underlying C GObject.
GSocketConnection * | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.
bool | connect (const Glib::RefPtr< SocketAddress > & address, const Glib::RefPtr< Cancellable > & cancellable)
| Connect connection to the specified remote address.
bool | connect (const Glib::RefPtr< SocketAddress > & address)
| A connect() convenience overload.
void | connect_async (const Glib::RefPtr< SocketAddress > & address, const SlotAsyncReady & slot, const Glib::RefPtr< Cancellable > & cancellable)
| Asynchronously connect this connection to the specified remote address.
void | connect_async (const Glib::RefPtr< SocketAddress > & address, const SlotAsyncReady & slot)
| A non-cancellable version of connect_async().
bool | connect_finish (const Glib::RefPtr< AsyncResult > & result)
| Gets the result of a g_socket_connection_connect_async() call.
bool | is_connected () const
| Checks if connection is connected.
Glib::RefPtr< Socket > | get_socket ()
| Gets the underlying Socket object of the connection.
Glib::RefPtr< const Socket > | get_socket () const
| Gets the underlying Socket object of the connection.
Glib::RefPtr< SocketAddress > | get_local_address ()
| Try to get the local address of a socket connection.
Glib::RefPtr< const SocketAddress > | get_local_address () const
| Try to get the local address of a socket connection.
Glib::RefPtr< SocketAddress > | get_remote_address ()
| Try to get the remote address of a socket connection.
Glib::RefPtr< const SocketAddress > | get_remote_address () const
| Try to get the remote address of a socket connection.
Glib::PropertyProxy_ReadOnly< Glib::RefPtr< Socket > > | property_socket () const
| The underlying GSocket.
Public Member Functions inherited from Gio::IOStream
| IOStream (IOStream && src) noexcept
IOStream & | operator= (IOStream && src) noexcept
| ~IOStream () noexcept override
GIOStream * | gobj ()
| Provides access to the underlying C GObject.
const GIOStream * | gobj () const
| Provides access to the underlying C GObject.
GIOStream * | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.
void | splice_async (const Glib::RefPtr< IOStream > & stream2, const SlotAsyncReady & slot, const Glib::RefPtr< Cancellable > & cancellable, IOStreamSpliceFlags flags=Gio::IO_STREAM_SPLICE_NONE, int io_priority=Glib::PRIORITY_DEFAULT)
| Asyncronously splice the output stream to the input stream of stream2, and splice the output stream of stream2 to the input stream of this stream.
void | splice_async (const Glib::RefPtr< IOStream > & stream2, const SlotAsyncReady & slot, IOStreamSpliceFlags flags=Gio::IO_STREAM_SPLICE_NONE, int io_priority=Glib::PRIORITY_DEFAULT)
| A non-cancellable version of splice_async().
Glib::RefPtr< InputStream > | get_input_stream ()
| Gets the input stream for this object.
Glib::RefPtr< OutputStream > | get_output_stream ()
| Gets the output stream for this object.
bool | close (const Glib::RefPtr< Cancellable > & cancellable)
| Closes the stream, releasing resources related to it.
bool | close ()
| A close() convenience overload.
void | close_async (const SlotAsyncReady & slot, const Glib::RefPtr< Cancellable > & cancellable, int io_priority=Glib::PRIORITY_DEFAULT)
void | close_async (const SlotAsyncReady & slot, int io_priority=Glib::PRIORITY_DEFAULT)
bool | close_finish (const Glib::RefPtr< AsyncResult > & result)
| Closes a stream.
bool | is_closed () const
| Checks if a stream is closed.
bool | has_pending () const
| Checks if a stream has pending actions.
bool | set_pending ()
| Sets stream to have actions pending.
void | clear_pending ()
| Clears the pending flag on stream.
Public Member Functions inherited from Glib::Object
| Object (const Object &)=delete
Object & | operator= (const Object &)=delete
| Object (Object && src) noexcept
Object & | operator= (Object && src) noexcept
void * | get_data (const QueryQuark & key)
void | set_data (const Quark & key, void *data)
void | set_data (const Quark & key, void *data, DestroyNotify notify)
void | remove_data (const QueryQuark & quark)
void * | steal_data (const QueryQuark & quark)
Public Member Functions inherited from Glib::ObjectBase
| ObjectBase (const ObjectBase &)=delete
ObjectBase & | operator= (const ObjectBase &)=delete
void | set_property_value (const Glib::ustring & property_name, const Glib::ValueBase & value)
| You probably want to use a specific property_*() accessor method instead.
void | get_property_value (const Glib::ustring & property_name, Glib::ValueBase & value) const
| You probably want to use a specific property_*() accessor method instead.
template<class PropertyType>
void | set_property (const Glib::ustring & property_name, const PropertyType & value)
| You probably want to use a specific property_*() accessor method instead.
template<class PropertyType>
void | get_property (const Glib::ustring & property_name, PropertyType & value) const
| You probably want to use a specific property_*() accessor method instead.
void | connect_property_changed (const Glib::ustring & property_name, const sigc::slot< void > & slot)
| You can use the signal_changed() signal of the property proxy instead.
void | connect_property_changed (const Glib::ustring & property_name, sigc::slot< void > && slot)
| You can use the signal_changed() signal of the property proxy instead.
sigc::connection | connect_property_changed_with_return (const Glib::ustring & property_name, const sigc::slot< void > & slot)
| You can use the signal_changed() signal of the property proxy instead.
sigc::connection | connect_property_changed_with_return (const Glib::ustring & property_name, sigc::slot< void > && slot)
| You can use the signal_changed() signal of the property proxy instead.
void | freeze_notify ()
| Increases the freeze count on object.
void | thaw_notify ()
| Reverts the effect of a previous call to freeze_notify().
virtual void | reference () const
| Increment the reference count for this object.
virtual void | unreference () const
| Decrement the reference count for this object.
GObject * | gobj ()
| Provides access to the underlying C GObject.
const GObject * | gobj () const
| Provides access to the underlying C GObject.
GObject * | gobj_copy () const
| Give a ref-ed copy to someone. Use for direct struct access.
Public Member Functions inherited from sigc::trackable
| trackable () noexcept
| trackable (const trackable &src) noexcept
| trackable (trackable &&src)
| ~trackable ()
void | add_destroy_notify_callback (void *data, func_destroy_notify func) const
void | notify_callbacks ()
trackable & | operator= (const trackable &src)
trackable & | operator= (trackable &&src)
void | remove_destroy_notify_callback (void *data) const

## Static Public Member Functions
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system.
Static Public Member Functions inherited from Gio::TcpConnection
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system.
Static Public Member Functions inherited from Gio::SocketConnection
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system.
static Glib::RefPtr< SocketConnection > | create (const Glib::RefPtr< Socket > &socket)
| Creates a SocketConnection subclass of the right type for socket.
Static Public Member Functions inherited from Gio::IOStream
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system.
static bool | splice_finish (const Glib::RefPtr< AsyncResult > & result)
| Finishes an asynchronous io stream splice operation.

## Related Symbols
(Note that these are not member symbols.)
Glib::RefPtr< Gio::TcpWrapperConnection > | wrap (GTcpWrapperConnection * object, bool take_copy=false)
| A Glib::wrap() method for this object.
Related Symbols inherited from Gio::TcpConnection
Glib::RefPtr< Gio::TcpConnection > | wrap (GTcpConnection * object, bool take_copy=false)
| A Glib::wrap() method for this object.
Related Symbols inherited from Gio::SocketConnection
Glib::RefPtr< Gio::SocketConnection > | wrap (GSocketConnection * object, bool take_copy=false)
| A Glib::wrap() method for this object.
Related Symbols inherited from Gio::IOStream
Glib::RefPtr< Gio::IOStream > | wrap (GIOStream * object, bool take_copy=false)
| A Glib::wrap() method for this object.
Related Symbols inherited from Glib::Object
Glib::RefPtr< Glib::Object > | wrap (GObject * object, bool take_copy=false)

## Additional Inherited Members
Public Types inherited from Glib::Object
using | DestroyNotify = void (*)(gpointer data)
Public Types inherited from sigc::trackable
typedef internal::func_destroy_notify | func_destroy_notify
Protected Member Functions inherited from Glib::Object
| Object ()
| Object (const Glib::ConstructParams & construct_params)
| Object (GObject * castitem)
| ~Object () noexcept override
Protected Member Functions inherited from Glib::ObjectBase
| ObjectBase ()
| This default constructor is called implicitly from the constructor of user-derived classes, even if, for instance, Gtk::Button calls a different ObjectBase constructor.
| ObjectBase (const char * custom_type_name)
| A derived constructor always overrides this choice.
| ObjectBase (const std::type_info & custom_type_info)
| This constructor is a special feature to allow creation of derived types on the fly, without having to use g_object_new() manually.
| ObjectBase (ObjectBase && src) noexcept
ObjectBase & | operator= (ObjectBase && src) noexcept
virtual | ~ObjectBase () noexcept=0
void | initialize (GObject * castitem)
void | initialize_move (GObject * castitem, Glib::ObjectBase * previous_wrapper)

## Detailed Description

Wrapper for non-GioSocketConnection-based, Gio::Socket-based Gio::IOStreams.

This can be used to wrap a Gio::Stream that is based on a Gio::Socket, but which is not actually a Gio::SocketConnection. This is used by Gio::SocketClient so that it can always return a Gio::SocketConnection, even when the connection it has actually created is not directly a Gio::SocketConnection.

Since glibmm 2.44

## Constructor & Destructor Documentation

## ◆ TcpWrapperConnection() [1/2]

Gio::TcpWrapperConnection::TcpWrapperConnection | ( | TcpWrapperConnection && | src | ) |
| noexcept

## ◆ ~TcpWrapperConnection()

Gio::TcpWrapperConnection::~TcpWrapperConnection | ( |  | ) |
| overridenoexcept

## ◆ TcpWrapperConnection() [2/2]

Gio::TcpWrapperConnection::TcpWrapperConnection | ( | const Glib::RefPtr< IOStream > & | base_io_stream,
|  | const Glib::RefPtr< Socket > & | socket )
| explicit

## Member Function Documentation

## ◆ get_base_io_stream() [1/2]

Glib::RefPtr< IOStream > Gio::TcpWrapperConnection::get_base_io_stream | ( |  | ) |

Gets conn's base IOStream.

Returns
  conn's base IOStream.

## ◆ get_base_io_stream() [2/2]

Glib::RefPtr< const IOStream > Gio::TcpWrapperConnection::get_base_io_stream | ( |  | ) | const

Gets conn's base IOStream.

Returns
  conn's base IOStream.

## ◆ get_type()

static GType Gio::TcpWrapperConnection::get_type | ( |  | ) |
| static

Get the GType for this class, for use with the underlying GObject type system.

## ◆ gobj() [1/2]

GTcpWrapperConnection * Gio::TcpWrapperConnection::gobj | ( |  | ) |
| inline

Provides access to the underlying C GObject.

## ◆ gobj() [2/2]

const GTcpWrapperConnection * Gio::TcpWrapperConnection::gobj | ( |  | ) | const
| inline

Provides access to the underlying C GObject.

## ◆ gobj_copy()

GTcpWrapperConnection * Gio::TcpWrapperConnection::gobj_copy | ( |  | ) |

Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.

## ◆ operator=()

TcpWrapperConnection & Gio::TcpWrapperConnection::operator= | ( | TcpWrapperConnection && | src | ) |
| noexcept

## ◆ property_base_io_stream()

Glib::PropertyProxy_ReadOnly< Glib::RefPtr< IOStream > > Gio::TcpWrapperConnection::property_base_io_stream | ( |  | ) | const

The wrapped GIOStream.

Since glibmm 2.44

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## Friends And Related Symbol Documentation

## ◆ wrap()

Glib::RefPtr< Gio::TcpWrapperConnection > wrap | ( | GTcpWrapperConnection * | object,
|  | bool | take_copy = false )
| related

A Glib::wrap() method for this object.

Parameters

  object | The C instance.
  take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns
  A C++ instance that wraps this C instance.